--If you do not want the mediguns to also be backpacks, change the value below to false.
local backpacksenabled = true

STRINGS = GLOBAL.STRINGS
ACTIONS = GLOBAL.ACTIONS
SpawnPrefab = GLOBAL.SpawnPrefab
RECIPETABS = GLOBAL.RECIPETABS
Recipe = GLOBAL.Recipe
Ingredient = GLOBAL.Ingredient
TECH = GLOBAL.TECH
Vector3 = GLOBAL.Vector3

PrefabFiles = {
	"quickfix",
	"qfaura",
	"medigun",
	"kritzkrieg",
	"mgcanteen",
	"kkcanteen",
	"medigunbeta"
}

AddMinimapAtlas("images/inventoryimages/medigun.xml")
AddMinimapAtlas("images/inventoryimages/medigunbeta.xml")
AddMinimapAtlas("images/inventoryimages/kritzkrieg.xml")
AddMinimapAtlas("images/inventoryimages/quickfix.xml")
AddMinimapAtlas("images/inventoryimages/kkcanteen.xml")
AddMinimapAtlas("images/inventoryimages/mgcanteen.xml")

GLOBAL.STRINGS.NAMES.MEDIGUN = "The Medi-Gun"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.MEDIGUN = "HA HA! I AM A GOD!"
STRINGS.RECIPE_DESC.MEDIGUN = "Come here, I promise I will heal you!"
function medigunrec()
local medigun = Recipe("medigun", {Ingredient("bluegem", 5),Ingredient("goldnugget", 15),Ingredient("bandage", 10),Ingredient("healingsalve", 10)}, RECIPETABS.SCIENCE, TECH.SCIENCE_TWO)
medigun.atlas = GLOBAL.resolvefilepath("images/inventoryimages/medigun.xml")
medigun.image = "medigun.tex"
end
AddGamePostInit(medigunrec)

GLOBAL.STRINGS.NAMES.KRITZKRIEG = "The Kritzkrieg"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.KRITZKRIEG = "It appears to be a device designed for either healing or busting ghosts..."
STRINGS.RECIPE_DESC.KRITZKRIEG = "Ze healing isn't as rewarding as Ze hurting!"
function kritzkriegrec()
local kritzkrieg = Recipe("kritzkrieg", {Ingredient("tentaclespike", 5),Ingredient("goldnugget", 15),Ingredient("bandage", 10),Ingredient("healingsalve", 10)}, RECIPETABS.SCIENCE, TECH.SCIENCE_TWO)
kritzkrieg.atlas = GLOBAL.resolvefilepath("images/inventoryimages/kritzkrieg.xml")
kritzkrieg.image = "kritzkrieg.tex"
end
AddGamePostInit(kritzkriegrec)

GLOBAL.STRINGS.NAMES.QUICKFIX = "The Quick-Fix"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.QUICKFIX = "\"WARNING: DO NOT CROSS THE STREAMS\" Why not?"
STRINGS.RECIPE_DESC.QUICKFIX = "Let's go practice medicine!"
function quickfixrec()
local quickfix = Recipe("quickfix", {Ingredient("redgem", 5),Ingredient("goldnugget", 15),Ingredient("bandage", 10),Ingredient("healingsalve", 10)}, RECIPETABS.SCIENCE, TECH.SCIENCE_TWO)
quickfix.atlas = GLOBAL.resolvefilepath("images/inventoryimages/quickfix.xml")
quickfix.image = "quickfix.tex"
end
AddGamePostInit(quickfixrec)

GLOBAL.STRINGS.NAMES.MEDIGUNBETA = "The Beta Medi-Gun"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.MEDIGUNBETA = "HA HA! I AM A BETA GOD!"
STRINGS.RECIPE_DESC.MEDIGUNBETA = "Zis next procedure vill be EXCRUCIATING!"
function medigunbetarec()
local medigun = Ingredient("medigun",1)
medigun.atlas = "images/inventoryimages/medigun.xml"
local kritzkrieg = Ingredient("kritzkrieg",1)
kritzkrieg.atlas = "images/inventoryimages/kritzkrieg.xml"
local quickfix = Ingredient("quickfix",1)
quickfix.atlas = "images/inventoryimages/quickfix.xml"
local medigunbeta = Recipe("medigunbeta", {medigun,kritzkrieg,quickfix}, RECIPETABS.SCIENCE, TECH.SCIENCE_TWO)
medigunbeta.atlas = GLOBAL.resolvefilepath("images/inventoryimages/medigunbeta.xml")
medigunbeta.image = "medigunbeta.tex"
end
AddGamePostInit(medigunbetarec)

GLOBAL.STRINGS.NAMES.MGCANTEEN = "Uber Canteen"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.MGCANTEEN = "Is almost as good..."
STRINGS.RECIPE_DESC.MGCANTEEN = "Good For One Medi-Gun Ubercharge"
function mgcanteenrec()
local mgcanteen = Recipe("mgcanteen", {Ingredient("goldnugget", 1),Ingredient("bandage", 1)}, RECIPETABS.SCIENCE, TECH.SCIENCE_ONE)
mgcanteen.atlas = GLOBAL.resolvefilepath("images/inventoryimages/mgcanteen.xml")
mgcanteen.image = "mgcanteen.tex"
end
AddGamePostInit(mgcanteenrec)

GLOBAL.STRINGS.NAMES.KKCANTEEN = "Kritz Canteen"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.KKCANTEEN = "Can still kill..."
STRINGS.RECIPE_DESC.KKCANTEEN = "Good For One Kritzkrieg Ubercharge"
function kkcanteenrec()
local kkcanteen = Recipe("kkcanteen", {Ingredient("goldnugget", 1),Ingredient("spear", 1)}, RECIPETABS.SCIENCE, TECH.SCIENCE_ONE)
kkcanteen.atlas = GLOBAL.resolvefilepath("images/inventoryimages/kkcanteen.xml")
kkcanteen.image = "kkcanteen.tex"
end
AddGamePostInit(kkcanteenrec)

local function standards(inst)
	GLOBAL.GetPlayer().ismgubered = 0
	GLOBAL.GetPlayer().iskkubered = 0
	GLOBAL.GetPlayer().isqfubered = 0
end
AddSimPostInit(standards)

local slotpos = {}
for y = 0, 3 do
	table.insert(slotpos, Vector3(-162, -y*75 + 114 ,0))
	table.insert(slotpos, Vector3(-162 +75, -y*75 + 114 ,0))
end
local function backpackadder(inst)
	if backpacksenabled then
		inst.components.inventoryitem.cangoincontainer = true
		inst:AddComponent("container")
		inst.components.container:SetNumSlots(#slotpos)
		inst.components.container.widgetslotpos = slotpos
		inst.components.container.widgetanimbank = "ui_backpack_2x4"
		inst.components.container.widgetanimbuild = "ui_backpack_2x4"
		inst.components.container.widgetpos = Vector3(-5,-50,0)
		inst.components.container.side_widget = true
		inst.components.container.type = "pack"
	end
end
AddPrefabPostInit("medigun", backpackadder)
AddPrefabPostInit("kritzkrieg", backpackadder)
AddPrefabPostInit("quickfix", backpackadder)
AddPrefabPostInit("medigunbeta", backpackadder)

local function overhealdropper(player)
	local GetPlayer = GLOBAL.GetPlayer
	GetPlayer().normalhp = GetPlayer().components.health.maxhealth
	GetPlayer().currentoverhealp = 0
	local temp = GetPlayer().normalhp * .25
	GetPlayer().overhealamount = math.floor(temp)
	GetPlayer().maxoverheal = GetPlayer().normalhp + GetPlayer().overhealamount
	player:DoPeriodicTask(.1, function(inst)
		if GetPlayer().isqfubered == 1 then
			GetPlayer().isoverhealed = 1
			GetPlayer().maxoverheal = GetPlayer().normalhp + GetPlayer().overhealamount
			GetPlayer().components.health.maxhealth = GetPlayer().maxoverheal
			GetPlayer().currentoverhealp = GetPlayer().components.health.maxhealth
		end
		if GetPlayer().isoverhealed == 1 then
			if GetPlayer().currentoverhealp <= GetPlayer().maxoverheal and GetPlayer().currentoverhealp > GetPlayer().normalhp then
--print(GetPlayer().components.health.currenthealth.."/"..GetPlayer().components.health.maxhealth)
				GetPlayer().currentoverhealp = GetPlayer().currentoverhealp - .1
				GetPlayer().components.health.maxhealth = GetPlayer().currentoverhealp
				GetPlayer().components.health:DoDelta(0, true)
			else
				GetPlayer().isoverhealed = 0
				GLOBAL.GetPlayer().components.health.maxhealth = GLOBAL.GetPlayer().normalhp
			end
		end
	end)
end
local require = GLOBAL.require
local Combat = require "components/combat"
local Combat_CalcDamage_base = Combat.CalcDamage
function Combat:CalcDamage(target, weapon, multiplier)
	local damage = Combat_CalcDamage_base(self, target, weapon, multiplier)
	if target == GLOBAL.GetPlayer() and GLOBAL.GetPlayer().isoverhealed == 1 and GLOBAL.GetPlayer().isqfubered == 0 then
		GLOBAL.GetPlayer().currentoverhealp = GLOBAL.GetPlayer().currentoverhealp - damage
--print("hit detected")
	end
--kritzkrieg uber:
	if self.inst == GLOBAL.GetPlayer() and target ~= GLOBAL.GetPlayer() and GLOBAL.GetPlayer().iskkubered == 1 then
		damage = damage * 3
	end
    return damage
end
AddSimPostInit(overhealdropper)

local function mediuber(player)
	local GetPlayer = GLOBAL.GetPlayer
	GetPlayer().ismgubered = 0
	player:DoPeriodicTask(.2, function(inst)
	if GetPlayer() and GetPlayer().components and GetPlayer().components.health then
		if GetPlayer().ismgubered == 1 then
			if GetPlayer().components.health.invincible == false then
				GetPlayer().components.health:SetInvincible(true)
			end
		end
		if GetPlayer().ismgubered == 0 then
			if GetPlayer().components.health.invincible == true then
				GetPlayer().components.health:SetInvincible(false)
			end
		end
		end
	end)
end
AddSimPostInit(mediuber)
--[[
local function kritzuber(player)
	local GetPlayer = GLOBAL.GetPlayer
	GetPlayer().iskkubered = 0
	local uberend = 0
	if GetPlayer().components.combat then
		if GetPlayer().components.combat.damagemultiplier == nil then
			GetPlayer().defaultdammulti = 1
			GetPlayer().defaultdamkrit = 3
		else
			GetPlayer().defaultdammulti = GetPlayer().components.combat.damagemultiplier
			local temp= GetPlayer().defaultdammulti * 3
--			math.floor(temp)
			GetPlayer().defaultdamkrit = temp
		end
	end
	player:DoPeriodicTask(.2, function(inst)
		if GetPlayer() and GetPlayer().components and GetPlayer().components.combat then
		if GetPlayer().iskkubered == 0 then
			if uberend == 1 then
				GetPlayer().components.combat.damagemultiplier = GetPlayer().defaultdammulti
				uberend = 0
			else
				if GetPlayer().components.combat.damagemultiplier == nil then
					GetPlayer().defaultdammulti = 1
					GetPlayer().defaultdamkrit = 3
				else
					GetPlayer().defaultdammulti = GetPlayer().components.combat.damagemultiplier
					local temp= GetPlayer().defaultdammulti * 3
--					math.floor(temp)
					GetPlayer().defaultdamkrit = temp
				end
			end
		end
		if GetPlayer().iskkubered == 1 then
			GetPlayer().components.combat.damagemultiplier = GetPlayer().defaultdamkrit
			uberend = 1
--print("calced! weapon=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.damage.. " base=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.kkbasedamage .. " kritz=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.kritzdamage)
		end
		end
	end)
end
--]]
--[[
local function kritzuber(player)
	local GetPlayer = GLOBAL.GetPlayer
	GetPlayer().iskkubered = 0
	player:DoPeriodicTask(.2, function(inst)
		if GetPlayer() and GetPlayer().components and GetPlayer().components.combat then
		if GetPlayer().iskkubered == 0 then
			GetPlayer().components.combat.damagemultiplier = 1
		end
		if GetPlayer().iskkubered == 1 then
			GetPlayer().components.combat.damagemultiplier = 3
--print("calced! weapon=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.damage.. " base=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.kkbasedamage .. " kritz=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.kritzdamage)
		end
		end
	end)
end
AddSimPostInit(kritzuber)
--]]

--some simple debug tools
--[[
spawnkeyt = GLOBAL.KEY_T
GetPlayer = GLOBAL.GetPlayer
GLOBAL.require("debugkeys")
local function spawnmg(player)
	GLOBAL.TheInput:AddKeyDownHandler(spawnkeyt, function(down)
		GLOBAL.DebugSpawn("kritzkrieg")
	end)
end
AddSimPostInit(spawnmg)
spawnkeyr = GLOBAL.KEY_R
GetPlayer = GLOBAL.GetPlayer
GLOBAL.require("debugkeys")
local function spawnfrog(player)
	GLOBAL.TheInput:AddKeyDownHandler(spawnkeyr, function(down)
		GLOBAL.DebugSpawn("frog")
	end)
end
AddSimPostInit(spawnfrog)
--]]
--[[
checkkey = GLOBAL.KEY_R
local function checkdam(player)
	GLOBAL.TheInput:AddKeyDownHandler(checkkey, function(down)
print("weapon=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.damage.. " base=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.kkbasedamage .. " kritz=" .. GetPlayer().components.inventory.equipslots.hands.components.weapon.kritzdamage)
	end)
end
AddSimPostInit(checkdam)
--]]
--debug printer:
--[[
local require = GLOBAL.require
local Combat = require "components/combat"
local Combat_CalcDamage_base = Combat.CalcDamage
function Combat:CalcDamage(target, weapon, multiplier)
	local damage = Combat_CalcDamage_base(self, target, weapon, multiplier)
    print(tostring(self.inst).." trying to do "..tostring(damage).." damage to "..tostring(target).." with "..tostring(weapon).." (multiplier: "..tostring(multiplier)..")")
    return damage
end
--]]
