local assets=
{
	Asset("ANIM", "anim/kkcanteen.zip"),
	Asset("ANIM", "anim/swap_kkcanteen.zip"),
	Asset("ATLAS", "images/inventoryimages/kkcanteen.xml"),
	Asset("IMAGE", "images/inventoryimages/kkcanteen.tex"),
}
local prefabs =
{
}

local function OnLoad(inst,data)
	inst.Light:Enable(false)
	inst.Light:SetRadius(0)
	if data and data.kkcanubercharge then
		if GetPlayer() then
			GetPlayer().iskkubered = 0
		end
		if data.kkcanubercharge == 100 then
			inst.kkubercharge = data.kkcanubercharge
			inst.kkuberchargemeter = inst.kkubercharge * .01
			inst.components.finiteuses:SetPercent(inst.kkuberchargemeter)
		else
			inst.kkubercharge = 0
			inst.components.finiteuses:SetPercent(0)
		end
	end
end

local function OnSave(inst, data)
    if inst.kkubercharge then
        data.kkcanubercharge = inst.kkubercharge
    end
end

local function kkcanuberpopped(inst)
    inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
	GetPlayer().components.talker:Say"IS GOOD TIME TO RUN, COWARDS!"
	inst:DoPeriodicTask(.1, function(inst)
			inst.kkubercharge = inst.kkubercharge - 1
			inst.kkuberchargemeter = inst.kkubercharge * .01
			inst.components.finiteuses:SetPercent(inst.kkuberchargemeter)
			if inst:HasTag("isequipped") then
				GetPlayer().iskkubered = 1
				if inst.kkubercharge > 16 then
					local color = Vector3(1,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.Light:Enable(true)
				end
				if inst.kkubercharge == 14 then
					local color = Vector3(0,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(false)
				end
				if inst.kkubercharge == 12 then
					local color = Vector3(1,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(true)
				end
				if inst.kkubercharge == 10 then
					local color = Vector3(0,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(false)
				end
				if inst.kkubercharge == 8 then
					local color = Vector3(1,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(true)
				end
				if inst.kkubercharge == 6 then
					local color = Vector3(0,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(false)
				end
				if inst.kkubercharge == 4 then
					local color = Vector3(1,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(true)
				end
				if inst.kkubercharge == 2 then
					local color = Vector3(0,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(false)
				end
				if inst.kkubercharge <= 0 then
					GetPlayer().iskkubered = 0
				end
			end
			if inst.kkubercharge <= 0 then
				inst:Remove()
			end
		end)
end

local function onequip(inst, owner)
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_kkcanteen", "backpack")
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_kkcanteen", "swap_body")
	inst:AddTag("isequipped")
	inst.initilized = 1
	inst.Light:SetRadius(1.5)
end

local function onunequip(inst, owner)
    GetPlayer().AnimState:ClearOverrideSymbol("swap_body")
    GetPlayer().AnimState:ClearOverrideSymbol("kkcanteen")
	inst:RemoveTag("isequipped")
	GetPlayer().iskkubered = 0
	inst.Light:Enable(false)
	inst.Light:SetRadius(0)
end

local slotpos = {}

for y = 0, 3 do
	table.insert(slotpos, Vector3(-162, -y*75 + 114 ,0))
	table.insert(slotpos, Vector3(-162 +75, -y*75 + 114 ,0))
end

local function fn(Sim)
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)

	inst.initilized = 0
	inst.kkubercharge = 100
	inst.kkuberchargemeter = 0
	inst.compadded = 0

	inst.entity:AddLight()
	inst.Light:Enable(false)
	inst.Light:SetRadius(1.5)
	inst.Light:SetFalloff(2)
	inst.Light:SetIntensity(.5)
	inst.Light:SetColour(255/255,1/255,1/255)


    inst.AnimState:SetBank("backpack1")
    inst.AnimState:SetBuild("swap_kkcanteen")
    inst.AnimState:PlayAnimation("anim")
    inst.entity:AddSoundEmitter()

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("kkcanteen.tex")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.cangoincontainer = true
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/backpack"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/kkcanteen.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(1)
	inst.components.finiteuses:SetPercent(1)

	inst:DoPeriodicTask(.1, function(inst)
		if inst:HasTag("isequipped") then
			if inst.compadded == 0 then
				inst.compadded = 1
				inst:AddComponent("useableitem")
				inst.components.useableitem:SetOnUseFn(kkcanuberpopped)
				inst.components.finiteuses:SetUses(1)
			end
		else
			inst:RemoveComponent("useableitem")
			inst.compadded = 0
		end
		if inst.kkubercharge <= 0 then
			inst:Remove()
		end
	end)

	inst.OnLoad = OnLoad
	inst.OnSave = OnSave

    return inst
end

return Prefab( "common/inventory/kkcanteen", fn, assets)
