local assets=
{
	Asset("ANIM", "anim/kritzkrieg.zip"),
	Asset("ANIM", "anim/swap_kritzkrieg.zip"),
	Asset("ATLAS", "images/inventoryimages/kritzkrieg.xml"),
	Asset("IMAGE", "images/inventoryimages/kritzkrieg.tex"),
}
local prefabs =
{
}

local function OnLoad(inst,data)
	if data and data.kkubercharge then
	inst.kkubercharge = data.kkubercharge
	inst.kkuberchargemeter = inst.kkubercharge * .01
	inst.components.finiteuses:SetPercent(inst.kkuberchargemeter)
	end
end

local function OnSave(inst, data)
    if inst.kkubercharge then
        data.kkubercharge = inst.kkubercharge
    end
end

local function mguberready(inst)
	inst:AddTag("kkactivated")
	inst.rand = math.random()
    inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
	if inst.rand <= .333 then
		GetPlayer().components.talker:Say"NOW! GO!"
	end
	if inst.rand > .334 and inst.rand <= .666 then
		GetPlayer().components.talker:Say"Auf Wiedersehen, DUMMKOPFS!"
	end
	if inst.rand > .667 and inst.rand <= 1 then
		GetPlayer().components.talker:Say"Auf Wiedersehen, SCHWEINEHUNDS!"
	end
end

local function onequip(inst, owner)
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_kritzkrieg", "backpack")
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_kritzkrieg", "swap_body")
	inst:AddTag("isequipped")
	inst.initilized = 1
	if inst.components.container then
		inst.components.container:Open(GetPlayer())
		GetPlayer().components.inventory:SetOverflow(inst)
	end
end

local function onunequip(inst, owner)
    GetPlayer().AnimState:ClearOverrideSymbol("swap_body")
    GetPlayer().AnimState:ClearOverrideSymbol("kritzkrieg")
	inst:RemoveTag("isequipped")
	if inst:HasTag("kkactivated") then
		local color = Vector3(0,0,0)
		GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
	end
	if inst.components.container then
		inst.components.container:Close(GetPlayer())
		GetPlayer().components.inventory:SetOverflow(nil)
	end
end

local function fn(Sim)
	local inst = CreateEntity()
--	inst.owner = GetPlayer()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)

	inst.initilized = 0
	inst.kkubercharge = 0
	inst.kkuberchargemeter = 0
	inst.kkchargenotified = 0
	local normalhp = 0
	inst.hpchecked = 0
	local color = 0

    inst.AnimState:SetBank("backpack1")
    inst.AnimState:SetBuild("swap_kritzkrieg")
    inst.AnimState:PlayAnimation("anim")
    inst.entity:AddSoundEmitter()

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("kritzkrieg.tex")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.cangoincontainer = true
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/backpack"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/kritzkrieg.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(1)
	inst.components.finiteuses:SetPercent(0)

--passive heal
	inst:DoPeriodicTask(1, function(inst)
		if inst:HasTag("isequipped") then
--print("passive heal")
			GetPlayer().components.health:DoDelta(3, true, nil, true)
		end
	end)

--charging uber
	inst:DoPeriodicTask(.75, function(inst)
	if inst:HasTag("isequipped") and not inst:HasTag("kkactivated") then
--print("charging uber")
		if inst.kkubercharge < 100 then
			inst.kkubercharge = inst.kkubercharge + 1
			inst.kkuberchargemeter = inst.kkubercharge * .01
			inst.components.finiteuses:SetPercent(inst.kkuberchargemeter)
		end
		if inst.kkubercharge > 99 and inst.kkubercharge < 101 and inst.kkchargenotified == 0 then
			inst.rand = math.random()
			if inst.rand <= .333 then
				GetPlayer().components.talker:Say"I AM CHARGED!"
			end
			if inst.rand > .334 and inst.rand <= .666 then
				GetPlayer().components.talker:Say"I AM FULLY CHARGED!"
			end
			if inst.rand > .667 and inst.rand <= 1 then
				GetPlayer().components.talker:Say"READY TO CHARGE!"
			end
			inst.kkchargenotified = 1
			inst:AddComponent("useableitem")
			inst.components.useableitem:SetOnUseFn(mguberready)
			inst.components.finiteuses:SetUses(1)
		end
	end
	end)

--uber active
	inst:DoPeriodicTask(.2, function(inst)
--		if GetPlayer() then
			if inst:HasTag("kkactivated") then
--print("uber active")
				inst.kkubercharge = inst.kkubercharge - 1
				inst.kkchargenotified = 0
				inst.kkuberchargemeter = inst.kkubercharge * .01
				inst.components.finiteuses:SetPercent(inst.kkuberchargemeter)
				if inst:HasTag("isequipped") then
					GetPlayer().iskkubered = 1
--					if GetPlayer().components.inventory.equipslots.hands and GetPlayer().components.inventory.equipslots.hands.components and GetPlayer().components.inventory.equipslots.hands.components.weapon and GetPlayer().components.inventory.equipslots.hands.components.weapon.damage then
					if inst.kkubercharge > 16 then
						local color = Vector3(1,0,0)
--						GetPlayer().components.inventory.equipslots.hands:AddComponent("highlight")
--						GetPlayer().components.inventory.equipslots.hands.Highlight:SetAddColour(color)
--						GetPlayer().components.inventory.equipslots.hands.Highlight:ApplyColour()
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					end
					if inst.kkubercharge == 14 then
						local color = Vector3(0,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					end
					if inst.kkubercharge == 12 then
						local color = Vector3(1,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					end
					if inst.kkubercharge == 10 then
						local color = Vector3(0,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					end
					if inst.kkubercharge == 8 then
						local color = Vector3(1,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					end
					if inst.kkubercharge == 6 then
						local color = Vector3(0,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					end
					if inst.kkubercharge == 4 then
						local color = Vector3(1,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					end
					if inst.kkubercharge == 2 then
						local color = Vector3(0,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					end
--					end
				else
					GetPlayer().iskkubered = 0
				end
			end
	--	end
		if GetPlayer() and inst.kkubercharge < 1 and inst.initilized == 1 and inst:HasTag("isequipped") then
			GetPlayer().iskkubered = 0
			inst:RemoveComponent("useableitem")
			if inst:HasTag("kkactivated") then
			inst:RemoveTag("kkactivated")
			end
			local color = Vector3(0,0,0)
			GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
		end
		if GetPlayer() and inst.kkubercharge < 1 and inst.initilized == 1 and inst:HasTag("kkactivated") then
			inst:RemoveTag("kkactivated")
			GetPlayer().iskkubered = 0
		end
			
	end)

	inst.OnLoad = OnLoad
	inst.OnSave = OnSave

    return inst
end

return Prefab( "common/inventory/kritzkrieg", fn, assets)
