local assets=
{
	Asset("ANIM", "anim/medigunbeta.zip"),
	Asset("ANIM", "anim/swap_medigunbeta.zip"),
	Asset("ATLAS", "images/inventoryimages/medigunbeta.xml"),
	Asset("IMAGE", "images/inventoryimages/medigunbeta.tex"),
}
local prefabs =
{
}

local function OnLoad(inst,data)
	if data and data.mgubercharge then
	if GetPlayer() then
		GetPlayer().ismgubered = 0
		GetPlayer().iskkubered = 0
	end
	inst.mgubercharge = data.mgubercharge
	inst.mguberchargemeter = inst.mgubercharge * .01
	inst.components.finiteuses:SetPercent(inst.mguberchargemeter)
	inst.Light:Enable(false)
	inst.Light:SetRadius(0)
	end
end

local function OnSave(inst, data)
    if inst.mgubercharge then
        data.mgubercharge = inst.mgubercharge
    end
end

local function mguberpopped(inst)
	inst:AddTag("mgactivated")
	GetPlayer().ismgubered = 1
	GetPlayer().iskkubered = 1
	inst.rand = math.random()
    inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
	if inst.rand <= .333 then
		GetPlayer().components.talker:Say"NOW! GO!"
	end
	if inst.rand > .334 and inst.rand <= .666 then
		GetPlayer().components.talker:Say"GET ZEM! RAUS! RAUS!"
	end
	if inst.rand > .667 and inst.rand <= 1 then
		GetPlayer().components.talker:Say"SCHNELL! GO GET ZEM!"
	end
end

local function onequip(inst, owner)
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_medigunbeta", "backpack")
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_medigunbeta", "swap_body")
	inst:AddTag("isequipped")
	inst.initilized = 1
	inst.Light:SetRadius(1.5)
	if inst.components.container then
		inst.components.container:Open(GetPlayer())
		GetPlayer().components.inventory:SetOverflow(inst)
	end
end

local function onunequip(inst, owner)
    GetPlayer().AnimState:ClearOverrideSymbol("swap_body")
    GetPlayer().AnimState:ClearOverrideSymbol("medigunbeta")
	inst:RemoveTag("isequipped")
	inst.Light:SetRadius(0)
	GetPlayer().ismgubered = 0
	GetPlayer().iskkubered = 0
	if inst:HasTag("mgactivated") then
		local color = Vector3(0,0,0)
		GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
	end
	inst.Light:SetRadius(0)
	if inst.components.container then
		inst.components.container:Close(GetPlayer())
		GetPlayer().components.inventory:SetOverflow(nil)
	end
end

local function fn(Sim)
	local inst = CreateEntity()
--	inst.owner = GetPlayer()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)

	inst.initilized = 0
	inst.mgubercharge = 0
	inst.mguberchargemeter = 0
	inst.mgchargenotified = 0

	inst.entity:AddLight()
	inst.Light:Enable(false)
	inst.Light:SetRadius(0)
	inst.Light:SetFalloff(2)
	inst.Light:SetIntensity(.5)
	inst.Light:SetColour(1/255,1/255,255/255)


    inst.AnimState:SetBank("backpack1")
    inst.AnimState:SetBuild("swap_medigunbeta")
    inst.AnimState:PlayAnimation("anim")
    inst.entity:AddSoundEmitter()

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("medigunbeta.tex")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.cangoincontainer = true
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/backpack"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/medigunbeta.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(1)
	inst.components.finiteuses:SetPercent(0)

--passive heal
	inst:DoPeriodicTask(1, function(inst)
		if inst:HasTag("isequipped") then
--print("passive heal")
			GetPlayer().components.health:DoDelta(3, true, nil, true)
		end
	end)

--charging uber
	inst:DoPeriodicTask(.9, function(inst)
	if inst:HasTag("isequipped") and not inst:HasTag("mgactivated") then
--print("charging uber")
		if inst.mgubercharge < 100 then
			inst.mgubercharge = inst.mgubercharge + 1
			inst.mguberchargemeter = inst.mgubercharge * .01
			inst.components.finiteuses:SetPercent(inst.mguberchargemeter)
		end
		if inst.mgubercharge > 99 and inst.mgubercharge < 101 and inst.mgchargenotified == 0 then
			inst.rand = math.random()
			if inst.rand <= .333 then
				GetPlayer().components.talker:Say"I AM CHARGED!"
			end
			if inst.rand > .334 and inst.rand <= .666 then
				GetPlayer().components.talker:Say"I AM FULLY CHARGED!"
			end
			if inst.rand > .667 and inst.rand <= 1 then
				GetPlayer().components.talker:Say"READY TO CHARGE!"
			end
			inst.mgchargenotified = 1
			inst:AddComponent("useableitem")
			inst.components.useableitem:SetOnUseFn(mguberpopped)
			inst.components.finiteuses:SetUses(1)
		end
	end
	end)

--uber active
	inst:DoPeriodicTask(.2, function(inst)
--		if GetPlayer() then
			if inst:HasTag("mgactivated") then
--print("uber active")
				inst.mgubercharge = inst.mgubercharge - 1
				inst.mgchargenotified = 0
				inst.mguberchargemeter = inst.mgubercharge * .01
				inst.components.finiteuses:SetPercent(inst.mguberchargemeter)
				if inst:HasTag("isequipped") then
					inst.Light:SetRadius(1.5)
					GetPlayer().ismgubered = 1
					GetPlayer().iskkubered = 1
					if inst.mgubercharge > 16 then
						local color = Vector3(0,0,1)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.Light:Enable(true)
					end
					if inst.mgubercharge == 14 then
						local color = Vector3(0,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
						inst.Light:Enable(false)
					end
					if inst.mgubercharge == 12 then
						local color = Vector3(0,0,1)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
						inst.Light:Enable(true)
					end
					if inst.mgubercharge == 10 then
						local color = Vector3(0,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
						inst.Light:Enable(false)
					end
					if inst.mgubercharge == 8 then
						local color = Vector3(0,0,1)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
						inst.Light:Enable(true)
					end
					if inst.mgubercharge == 6 then
						local color = Vector3(0,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
						inst.Light:Enable(false)
					end
					if inst.mgubercharge == 4 then
						local color = Vector3(0,0,1)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
						inst.Light:Enable(true)
					end
					if inst.mgubercharge == 2 then
						local color = Vector3(0,0,0)
						GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
						inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
						inst.Light:SetRadius(0)
						inst.Light:Enable(false)
					end
				end
			end
	--	end
		if GetPlayer() and inst.mgubercharge < 1 and inst.initilized == 1 and inst:HasTag("isequipped") then
			inst:RemoveComponent("useableitem")
			if inst:HasTag("mgactivated") then
			inst:RemoveTag("mgactivated")
			end
			GetPlayer().ismgubered = 0
			GetPlayer().iskkubered = 0
			inst.Light:Enable(false)
			local color = Vector3(0,0,0)
			GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
		end
		if GetPlayer() and inst.mgubercharge < 1 and inst.initilized == 1 and inst:HasTag("mgactivated") then
			inst:RemoveTag("mgactivated")
		end
			
	end)

	inst.OnLoad = OnLoad
	inst.OnSave = OnSave

    return inst
end

return Prefab( "common/inventory/medigunbeta", fn, assets)
