local assets=
{
	Asset("ANIM", "anim/mgcanteen.zip"),
	Asset("ANIM", "anim/swap_mgcanteen.zip"),
	Asset("ATLAS", "images/inventoryimages/mgcanteen.xml"),
	Asset("IMAGE", "images/inventoryimages/mgcanteen.tex"),
}
local prefabs =
{
}

local function OnLoad(inst,data)
	inst.Light:Enable(false)
	inst.Light:SetRadius(0)
	if data and data.mgcanubercharge then
		if GetPlayer() then
			GetPlayer().ismgubered = 0
		end
		if data.mgcanubercharge == 100 then
			inst.mgubercharge = data.mgcanubercharge
			inst.mguberchargemeter = inst.mgubercharge * .01
			inst.components.finiteuses:SetPercent(inst.mguberchargemeter)
		else
			inst.mgubercharge = 0
			inst.components.finiteuses:SetPercent(0)
		end
	end
end

local function OnSave(inst, data)
    if inst.mgubercharge then
        data.mgcanubercharge = inst.mgubercharge
    end
end

local function mgcanuberpopped(inst)
    inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
	GetPlayer().components.talker:Say"I AM BULLET PROOF!"
	inst:DoPeriodicTask(.1, function(inst)
			inst.mgubercharge = inst.mgubercharge - 1
			inst.mguberchargemeter = inst.mgubercharge * .01
			inst.components.finiteuses:SetPercent(inst.mguberchargemeter)
			if inst:HasTag("isequipped") then
				inst.Light:SetRadius(1.5)
				GetPlayer().ismgubered = 1
				if inst.mgubercharge > 16 then
					local color = Vector3(0,0,1)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.Light:Enable(true)
				end
				if inst.mgubercharge == 14 then
					local color = Vector3(0,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(false)
				end
				if inst.mgubercharge == 12 then
					local color = Vector3(0,0,1)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(true)
				end
				if inst.mgubercharge == 10 then
					local color = Vector3(0,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(false)
				end
				if inst.mgubercharge == 8 then
					local color = Vector3(0,0,1)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(true)
				end
				if inst.mgubercharge == 6 then
					local color = Vector3(0,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(false)
				end
				if inst.mgubercharge == 4 then
					local color = Vector3(0,0,1)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(true)
				end
				if inst.mgubercharge == 2 then
					local color = Vector3(0,0,0)
					GetPlayer().AnimState:SetAddColour(color.x, color.y, color.z ,0)
					inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/spark")
					inst.Light:Enable(false)
				end
				if inst.mgubercharge <= 0 then
					GetPlayer().ismgubered = 0
				end
			end
			if inst.mgubercharge <= 0 then
				inst:Remove()
			end
		end)
end

local function onequip(inst, owner)
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_mgcanteen", "backpack")
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_mgcanteen", "swap_body")
	inst:AddTag("isequipped")
	inst.initilized = 1
	inst.Light:SetRadius(0)
end

local function onunequip(inst, owner)
    GetPlayer().AnimState:ClearOverrideSymbol("swap_body")
    GetPlayer().AnimState:ClearOverrideSymbol("mgcanteen")
	inst:RemoveTag("isequipped")
	GetPlayer().ismgubered = 0
	inst.Light:Enable(false)
	inst.Light:SetRadius(0)
end

local slotpos = {}

for y = 0, 3 do
	table.insert(slotpos, Vector3(-162, -y*75 + 114 ,0))
	table.insert(slotpos, Vector3(-162 +75, -y*75 + 114 ,0))
end

local function fn(Sim)
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)

	inst.initilized = 0
	inst.mgubercharge = 100
	inst.mguberchargemeter = 0
	inst.compadded = 0

	inst.entity:AddLight()
	inst.Light:Enable(false)
	inst.Light:SetRadius(0)
	inst.Light:SetFalloff(2)
	inst.Light:SetIntensity(.5)
	inst.Light:SetColour(1/255,1/255,255/255)


    inst.AnimState:SetBank("backpack1")
    inst.AnimState:SetBuild("swap_mgcanteen")
    inst.AnimState:PlayAnimation("anim")
    inst.entity:AddSoundEmitter()

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("mgcanteen.tex")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.cangoincontainer = true
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/backpack"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/mgcanteen.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(1)
	inst.components.finiteuses:SetPercent(1)

	inst:DoPeriodicTask(.1, function(inst)
		if inst:HasTag("isequipped") then
			if inst.compadded == 0 then
				inst.compadded = 1
				inst:AddComponent("useableitem")
				inst.components.useableitem:SetOnUseFn(mgcanuberpopped)
				inst.components.finiteuses:SetUses(1)
			end
		else
			inst:RemoveComponent("useableitem")
			inst.compadded = 0
		end
		if inst.mgubercharge <= 0 then
			inst:Remove()
		end
	end)

	inst.OnLoad = OnLoad
	inst.OnSave = OnSave

    return inst
end

return Prefab( "common/inventory/mgcanteen", fn, assets)
