local assets=
{
	Asset("ANIM", "anim/quickfix.zip"),
	Asset("ANIM", "anim/swap_quickfix.zip"),
	Asset("ATLAS", "images/inventoryimages/quickfix.xml"),
	Asset("IMAGE", "images/inventoryimages/quickfix.tex"),
}
local prefabs =
{
--	"qfaura"
}

local function OnLoad(inst,data)
	inst.performsetup = 1
	if data and data.qfubercharge then
		inst.qfubercharge = data.qfubercharge
		inst.qfuberchargemeter = inst.qfubercharge * .01
		inst.components.finiteuses:SetPercent(inst.qfuberchargemeter)
	end
end

local function OnSave(inst, data)
    if inst.qfubercharge then
        data.qfubercharge = inst.qfubercharge
    end
end

local function qfuberpopped(inst)
	if GetPlayer().isoverhealed ~= 1 then
		GetPlayer().normalhp = GetPlayer().components.health.maxhealth
		local temp = GetPlayer().normalhp * .25
		GetPlayer().overhealamount = math.floor(temp)
		GetPlayer().maxoverheal = GetPlayer().normalhp + GetPlayer().overhealamount
	end
	GetPlayer().isqfubered = 1
	GetPlayer().isoverhealed = 1
	inst.qfon = 1
    inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
	inst.rand = math.random()
	if inst.rand <= .333 then
		GetPlayer().components.talker:Say"NOW! GO!"
	end
	if inst.rand > .334 and inst.rand <= .666 then
		GetPlayer().components.talker:Say"Auf Wiedersehen, DUMMKOPFS!"
	end
	if inst.rand > .667 and inst.rand <= 1 then
		GetPlayer().components.talker:Say"Auf Wiedersehen, SCHWEINEHUNDS!"
	end
end

local function onequip(inst, owner)
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_quickfix", "backpack")
    GetPlayer().AnimState:OverrideSymbol("swap_body", "swap_quickfix", "swap_body")
	inst:AddTag("isequipped")
	inst.initilized = 1
	if inst.components.container then
		inst.components.container:Open(GetPlayer())
		GetPlayer().components.inventory:SetOverflow(inst)
	end
end

local function onunequip(inst, owner)
	inst:RemoveTag("isequipped")
    GetPlayer().AnimState:ClearOverrideSymbol("swap_body")
    GetPlayer().AnimState:ClearOverrideSymbol("quickfix")
	GetPlayer().isqfubered = 0
	if inst.components.container then
		inst.components.container:Close(GetPlayer())
		GetPlayer().components.inventory:SetOverflow(nil)
	end
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.owner = GetPlayer()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)

--custom vars
	inst.overhealenabled = 1
--	inst.doitemsetup = 1
	inst.initilized = 0
--	inst.performsetup = 0
	inst.sparks_time = 3
	inst.qfubercharge = 0
	inst.qfuberchargemeter = 0
	inst.qfchargenotified = 0
	inst.hpchecked = 0
	inst.ubercherrypopped = 0
	inst.qfon = 0

    inst.AnimState:SetBank("backpack1")
    inst.AnimState:SetBuild("swap_quickfix")
    inst.AnimState:PlayAnimation("anim")

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("quickfix.tex")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.cangoincontainer = true
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/backpack"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/quickfix.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(1)
	inst.components.finiteuses:SetPercent(0)
--[[
--load setup
	inst:DoPeriodicTask(.1, function(inst)
	if inst.performsetup == 1 then
		inst.performsetup = 0
		GetPlayer().isoverhealed = 0
		GetPlayer().normalhp = GetPlayer().components.health.maxhealth
		GetPlayer().currentoverhealp = 0
		local temp = GetPlayer().normalhp * .25
		GetPlayer().overhealamount = math.floor(temp)
		GetPlayer().maxoverheal = GetPlayer().normalhp + GetPlayer().overhealamount
	end
--item setup
	if GetPlayer().isqfubered ~= 1 and GetPlayer().isoverhealed ~= 1 and inst.doitemsetup == 1 then
		inst.doitemsetup = 0
		GetPlayer().normalhp = GetPlayer().components.health.maxhealth
		GetPlayer().currentoverhealp = 0
		local temp = GetPlayer().normalhp * .25
		GetPlayer().overhealamount = math.floor(temp)
		GetPlayer().maxoverheal = GetPlayer().normalhp + GetPlayer().overhealamount	
--		GetPlayer().isoverhealed = 0
	end
	end)
--]]

--passive heal
	inst:DoPeriodicTask(1, function(inst)
		if inst:HasTag("isequipped") then
			GetPlayer().components.health:DoDelta(3, true, nil, true)
		end
	end)

--charging uber
	inst:DoPeriodicTask(.6, function(inst)
	if inst:HasTag("isequipped") and inst.qfon == 0 then
		if inst.qfubercharge < 100 then
			inst.qfubercharge = inst.qfubercharge + 1
			inst.qfuberchargemeter = inst.qfubercharge * .01
			inst.components.finiteuses:SetPercent(inst.qfuberchargemeter)
		end
		if inst.qfubercharge > 99 and inst.qfubercharge < 101 and inst.qfchargenotified == 0 then
			inst.rand = math.random()
			if inst.rand <= .333 then
				GetPlayer().components.talker:Say"I AM CHARGED!"
			end
			if inst.rand > .334 and inst.rand <= .666 then
				GetPlayer().components.talker:Say"I AM FULLY CHARGED!"
			end
			if inst.rand > .667 and inst.rand <= 1 then
				GetPlayer().components.talker:Say"READY TO CHARGE!"
			end
			inst.qfchargenotified = 1
			inst:AddComponent("useableitem")
			inst.components.useableitem:SetOnUseFn(qfuberpopped)
			inst.components.finiteuses:SetUses(1)
		end
	end
	end)

--uber active
	inst:DoPeriodicTask(.2, function(inst)
		if GetPlayer() then
			if inst.qfon == 1 then
				inst.qfubercharge = inst.qfubercharge - 1
				inst.qfchargenotified = 0
				inst.qfuberchargemeter = inst.qfubercharge * .01
				inst.components.finiteuses:SetPercent(inst.qfuberchargemeter)
				if inst:HasTag("isequipped") then
--print("megaheal on")
					GetPlayer().isqfubered = 1
					GetPlayer().components.health:DoDelta(50, false)
					inst.sparks_time = 3+math.random()*2
					local pos = Vector3(inst.Transform:GetWorldPosition())
					local sparks = SpawnPrefab("qfaura")
					sparks.Transform:SetPosition(pos:Get())
				end
			end
		end
		if GetPlayer() and inst.qfubercharge < 1 then
			inst:RemoveComponent("useableitem")
--			GetPlayer().isqfubered = 0
			inst.qfon = 0
		end
		if GetPlayer() and inst:HasTag("isequipped") and inst.qfubercharge < 1 and inst.initilized == 1 and inst.qfon == 0 then
			GetPlayer().isqfubered = 0
		end

	end)

--overheal manager
	inst:DoPeriodicTask(.5, function(inst)
	if inst.overhealenabled == 1 then
		if GetPlayer().currentoverhealp <= GetPlayer().maxoverheal and GetPlayer().currentoverhealp > GetPlayer().normalhp then
			inst.ubercherrypopped = 1
		end
--		if inst:HasTag("isequipped") and GetPlayer().isqfubered == 1 and inst.qfon == 1 then
--print("uber active")
--			GetPlayer().isoverhealed = 1
--			GetPlayer().maxoverheal = GetPlayer().normalhp + GetPlayer().overhealamount
--			GetPlayer().components.health.maxhealth = GetPlayer().maxoverheal
--			GetPlayer().currentoverhealp = GetPlayer().components.health.maxhealth
--		end
		if GetPlayer().currentoverhealp <= GetPlayer().normalhp and GetPlayer().isoverhealed == 0 and inst:HasTag("isequipped") and GetPlayer().isqfubered == 0 then
--print("hp checked")
--print(GetPlayer().components.health.currenthealth .. "/" .. GetPlayer().components.health.maxhealth)
			GetPlayer().normalhp = GetPlayer().components.health.maxhealth
		local temp = GetPlayer().normalhp * .25
		GetPlayer().overhealamount = math.floor(temp)
			GetPlayer().maxoverheal = GetPlayer().normalhp + GetPlayer().overhealamount
		end

--[[
		local overhealamount = GetPlayer().maxoverheal - GetPlayer().normalhp
		if overhealamount > 1 and overhealamount < inst.maxoverheal and GetPlayer().isqfubered == 0 and GetPlayer().isoverhealed == 1 then
print("hit detected")
			inst.maxoverheal = GetPlayer().normalhp + overhealamount
			GetPlayer().maxoverheal = inst.maxoverheal
		end
--]]
	end
	end)

	inst.OnLoad = OnLoad
	inst.OnSave = OnSave

    return inst
end

return Prefab( "common/inventory/quickfix", fn, assets)
